﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter.Events;
using Infragistics.Windows.DataPresenter;

namespace xamSparklineInGridDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            //Create a DataSet from Northwind's Customers and Orders:
            System.Data.DataSet customerDS = SampleDataUtil.GetCustomersOrders(".\\SQLExpress");
            if (customerDS.Tables["Customers"] != null)
            {
                //and if available set it as data source to the grid
                this.XamDataGrid.DataSource = customerDS.Tables["Customers"].DefaultView;
            }
        }

        private void XamDataGrid_InitializeRecord(object sender, InitializeRecordEventArgs e)
        {
            if (e.Record is DataRecord)
            {
                //get the data record and verify it is a parent row:
                DataRecord dr = (DataRecord)e.Record;
                if (dr.HasExpandableFieldRecords)
                {
                    List<int> values = new List<int>();
                    foreach (ExpandableFieldRecord row in dr.ChildRecords)
                    {
                        RecordCollectionBase recColBase = row.ChildRecords;
                        //go through all the child records
                        foreach (Record childRec in recColBase)
                        {
                            //and build value collections with Freight expenses for each:
                            values.Add((int)double.Parse((childRec as DataRecord).Cells["Freight"].Value.ToString()));
                        }
                        //build nice parsable string with the values:
                        StringBuilder sb = new StringBuilder();
                        values.ForEach( delegate(int value) { sb.Append(value.ToString() + " "); });
                        // set that string as value of the parent's Chart cell
                        dr.Cells["Chart"].Value = sb.ToString();
                    }
                }
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            this.XamDataGrid.FieldLayouts[0].Fields["Chart"].Settings.CellValuePresenterStyle = (Style)this.Resources["ColumnsStyle"];
        }
    }
}
