﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Data;
using Infragistics.Windows.DataPresenter;

namespace xamSparklineInGridDemo
{
    class SourceConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            //skip the first (header) cell
            if ((value as CellValuePresenter).Record.DataItemIndex != -1)
            {
                //get the value, split it and parse each to int
                string values = (string)(value as CellValuePresenter).Record.Cells["Chart"].Value;
                List<int> convertedValues = new List<int>();
                List<string> separates = values.Split(new char[] { ' ' }, StringSplitOptions.RemoveEmptyEntries).ToList();
                convertedValues = separates.ConvertAll(x => int.Parse(x));
                //return the list with int values:
                return convertedValues;
            }
            return null;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
